unit Player;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, ExtCtrls, ComCtrls, XaudioPlayer,
  ACTIVESKINLib_TLB, OleCtrls, FileCtrl, ImgList;

type
  TPlayerForm = class(TForm)
    OpenFileDialog: TOpenDialog;
    XaudioPlayer: TXaudioPlayer;
    TrackBar1: TTrackBar;
    pause: TSkinButton;
    stop: TSkinButton;
    PlayName: TSkinLabel;
    TimecodeText: TSkinLabel;
    play: TSkinButton;
    DurationText1: TSkinLabel;
    TrackBar: TSkinScrollBar;
    eq: TSkinButton;
    InputNameText: TStaticText;
    pl: TSkinButton;
    ImageList: TImageList;
    back: TSkinButton;
    kt: TSkinButton;
    kj: TSkinButton;
    next: TSkinButton;
    SkinForm: TSkinForm;
    Menu: TPopupMenu;
    N10: TMenuItem;
    N27: TMenuItem;
    N32: TMenuItem;
    N35: TMenuItem;
    StatusBar: TStatusBar;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    MP: TMenuItem;
    mpl: TMenuItem;
    url: TMenuItem;
    meq: TMenuItem;
    N4: TMenuItem;
    exit: TMenuItem;
    page: TMenuItem;
    email: TMenuItem;
    N5: TMenuItem;
    N54: TMenuItem;
    N51: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    mplay: TMenuItem;
    mpause: TMenuItem;
    mstopa: TMenuItem;
    N13: TMenuItem;
    mkj: TMenuItem;
    mkt: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    sk: TOpenDialog;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    skinbox: TListBox;
    procedure XaudioPlayerNotifyinputName(Sender: TXaudioPlayer;
      const Name: String);
    procedure XaudioPlayerNotifyInputState(Sender: TXaudioPlayer;
      State: Integer);
    procedure XaudioPlayerNotifyNack(Sender: TXaudioPlayer; Command: Byte;
      Code: Smallint);
    procedure XaudioPlayerNotifyOutputName(Sender: TXaudioPlayer;
      const Name: String);
     procedure XaudioPlayerNotifyInputPosition(Sender: TXaudioPlayer;
      Offset, Range: Cardinal);
    procedure XaudioPlayerNotifyInputTimecode(Sender: TXaudioPlayer; Hours,
      Minutes, Seconds, Fractions: Byte);
    procedure FormDestroy(Sender: TObject);
    procedure XaudioPlayerNotifyInputModule(Sender: TXaudioPlayer;
      ID: SmallInt);
    procedure XaudioPlayerNotifyOutputState(Sender: TXaudioPlayer;
      State: Integer);
    procedure XaudioPlayerNotifyOutputVolume(Sender: TXaudioPlayer;
      MasterLevel, PcmLevel, Balance: Byte);
    procedure XaudioPlayerNotifyOutputPcmLevel(Sender: TXaudioPlayer;
      PcmLevel: Byte);
    procedure XaudioPlayerNotifyOutputMasterLevel(Sender: TXaudioPlayer;
      MasterLevel: Byte);
    procedure XaudioPlayerNotifyInputDuration(Sender: TXaudioPlayer;
      Duration: Cardinal);
    procedure playClick(Sender: TObject);
    procedure pauseClick(Sender: TObject);
    procedure stopClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure eqClick(Sender: TObject);
    procedure ktClick(Sender: TObject);
    procedure kjClick(Sender: TObject);
    procedure plClick(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure nextClick(Sender: TObject);
    procedure backClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mpClick(Sender: TObject);
    procedure urlClick(Sender: TObject);
    procedure N51Click(Sender: TObject);
    procedure N54Click(Sender: TObject);
    procedure XaudioPlayerNotifyPlayerState(Sender: TXaudioPlayer;
      State: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure N4Click(Sender: TObject);
    procedure exitClick(Sender: TObject);
    procedure pageClick(Sender: TObject);
    procedure emailClick(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N19Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
public
    { Public declarations }
  end;

var
  PlayerForm: TPlayerForm;

implementation

uses URLEntry, Volume, Info, Equalizer, Modules,  Unit1, Unit2, Unit3;

{$R *.DFM}

procedure ShowError(Text: String; Code: Integer);
var
  Msg: String;
begin
  Msg := Text + ' (' + PlayerForm.XaudioPlayer.ErrorString(code) + ')';
  MessageDlg(Msg, mtError, [mbOK], 0);
end;
procedure TPlayerForm.XaudioPlayerNotifyinputName(Sender: TXaudioPlayer;
  const Name: String);
begin
  InputNameText.Caption := Name;
  InfoForm.InputNameText.Caption := Name;
  PlayName.Text:= InputNameText.Caption ;
end ;
procedure TPlayerForm.XaudioPlayerNotifyInputState(Sender: TXaudioPlayer;
  State: Integer);
begin
  if State = XA_INPUT_STATE_OPEN then
    begin
      stop.Enabled:=true   ;
      mstopa.Enabled:=true  ;
      pause.Enabled:=true ;
      mpause.Enabled:=true ;
      play.enabled:=false ;
      mplay.Enabled:=false  ;
      xaudioplayer.play ;
end
  else
    begin
stop.Enabled:=false   ;
mstopa.Enabled:=false  ;
pause.Enabled:=false ;
mpause.Enabled:=false ;
play.enabled:=false  ;
mplay.Enabled:=false  ;
    end;
end;
procedure TPlayerForm.XaudioPlayerNotifyNack(Sender: TXaudioPlayer;
  Command: Byte; Code: Smallint);
begin
  case Command of
  XA_MSG_COMMAND_INPUT_OPEN:
    ShowError('Cannot Open Input', Code);

  XA_MSG_COMMAND_PLAY:
    ShowError('Cannot Play Stream', Code);
  end;
end;
procedure TPlayerForm.XaudioPlayerNotifyOutputName(Sender: TXaudioPlayer;
  const Name: String);
begin
  InfoForm.InputNameText.Caption := Name;
end;
procedure TPlayerForm.XaudioPlayerNotifyInputPosition(
  Sender: TXaudioPlayer; Offset, Range: Cardinal);
begin
  TrackBar.value := Offset;
end;
procedure TPlayerForm.XaudioPlayerNotifyInputTimecode(
  Sender: TXaudioPlayer; Hours, Minutes, Seconds, Fractions: Byte);
begin
  TimecodeText.text := Format('%.2d:%.2d:%.2d', [Hours, Minutes, Seconds]);
end;
procedure TPlayerForm.FormDestroy(Sender: TObject);
begin
   XaudioPlayer.OutputReset;
   XaudioPlayer.Exit;
end;
procedure TPlayerForm.XaudioPlayerNotifyInputModule(Sender: TXaudioPlayer;
  ID: SmallInt);
begin
  InfoForm.InputModuleText.Caption := IntToStr(ID);
end;
procedure TPlayerForm.XaudioPlayerNotifyOutputState(Sender: TXaudioPlayer;
  State: Integer);
begin
  if (state = XA_OUTPUT_STATE_OPEN) then
    VolumeForm.Enabled := True
  else
    VolumeForm.Enabled := False;
end;
procedure TPlayerForm.XaudioPlayerNotifyOutputVolume(Sender: TXaudioPlayer;
  MasterLevel, PcmLevel, Balance: Byte);
begin
  VolumeForm.MasterTrackBar.Position := MasterLevel;
  VolumeForm.PcmTrackBar.Position := PcmLevel;
  VolumeForm.BalanceTrackBar.Position := Balance;
end;
procedure TPlayerForm.XaudioPlayerNotifyOutputPcmLevel(
  Sender: TXaudioPlayer; PcmLevel: Byte);
begin
  VolumeForm.PcmTrackBar.Position := PcmLevel;
end;
procedure TPlayerForm.XaudioPlayerNotifyOutputMasterLevel(
  Sender: TXaudioPlayer; MasterLevel: Byte);
begin
  VolumeForm.MasterTrackBar.Position := MasterLevel;
end;
procedure TPlayerForm.XaudioPlayerNotifyInputDuration(
  Sender: TXaudioPlayer; Duration: Cardinal);
var
  Hours: Integer;
  Minutes: Integer;
  Seconds: Integer;
begin
  Hours := Duration div 3600;
  Duration := Duration - 3600*Hours;
  Minutes := Duration div 60;
  Duration := Duration - 60*Minutes;
  Seconds := Duration;
  DurationText1.text := Format('%.2d:%.2d:%.2d', [Hours, Minutes, Seconds]);
end;
procedure TPlayerForm.playClick(Sender: TObject);
begin
xaudioplayer.play ;
stop.Enabled:=true   ;
mstopa.Enabled:=true  ;
pause.Enabled:=true ;
mpause.Enabled:=true ;
play.enabled:=false ;
mplay.Enabled:=false  ;
end;
procedure TPlayerForm.pauseClick(Sender: TObject);
begin
xaudioplayer.pause ;
stop.Enabled:=true   ;
mstopa.Enabled:=true  ;
pause.Enabled:=false ;
mpause.Enabled:=false ;
play.enabled:=true  ;
mplay.Enabled:=true  ;
end;
procedure TPlayerForm.stopClick(Sender: TObject);
begin
xaudioplayer.pause;
TrackBar1.Position:=0 ;
XaudioPlayer.InputSeek(TrackBar1.Position, TrackBar1.Max);
stop.Enabled:=false  ;
mstopa.Enabled:=false  ;
pause.Enabled:=false  ;
mpause.Enabled:=false     ;
play.enabled:=true     ;
mplay.Enabled:=true  ;
end;
Procedure TPlayerForm.TrackBar1Change(Sender: TObject);
begin
  XaudioPlayer.InputSeek(TrackBar1.Position, TrackBar1.Max);
end;
procedure TPlayerForm.eqClick(Sender: TObject);
begin
EqualizerForm.Show;
end;
procedure TPlayerForm.plClick(Sender: TObject);
begin
playlist.ListBox.Items.LoadFromFile('c:\windows\flashamp2000.m3u');
playlist.Show;
end;
procedure TPlayerForm.ktClick(Sender: TObject);
begin
TrackBar.Position:=TrackBar.Value-10;
end;
procedure TPlayerForm.kjClick(Sender: TObject);
begin
TrackBar1.Position:=TrackBar.Value+10;
end;
procedure TPlayerForm.N7Click(Sender: TObject);
begin
Volumeform.BalanceTrackBar.Position:=50 ;
end;
procedure TPlayerForm.nextClick(Sender: TObject);
begin
playlist.listbox.itemindex:=playlist.listbox.itemindex +1 ;
playerform.XaudioPlayer.inputopen(playlist.ListBox.items[playlist.listbox.itemindex]);
xaudioplayer.play;
end;
procedure TPlayerForm.backClick(Sender: TObject);
begin
if playlist.listbox.itemindex >=1 then
Begin
playlist.ListBox.ItemIndex := playlist.ListBox.ItemIndex -1;
playerform.XaudioPlayer.inputopen(playlist.ListBox.items[playlist.listbox.itemindex]);
xaudioplayer.Play;
end
end;
procedure TPlayerForm.FormShow(Sender: TObject);
begin
    play.ApplySkin(skinform.ControlInterface);
    pause.ApplySkin(skinform.ControlInterface);
    stop.ApplySkin(skinform.ControlInterface);
    eq.ApplySkin(skinform.ControlInterface);
    pl.ApplySkin(skinform.ControlInterface);
    kj.ApplySkin(skinform.ControlInterface);
    kt.ApplySkin(skinform.ControlInterface);
    back.ApplySkin(skinform.ControlInterface);
    next.ApplySkin(skinform.ControlInterface);
    playname.ApplySkin(skinform.ControlInterface);
    DurationText1.ApplySkin(skinform.ControlInterface);
    TimecodeText.ApplySkin(skinform.ControlInterface);
    TrackBar.ApplySkin(skinform.ControlInterface);
end;
procedure TPlayerForm.mpClick(Sender: TObject);
begin
  if OpenFileDialog.Execute then
  begin
    XaudioPlayer.InputOpen(OpenFileDialog.FileName);
    playlist.ListBox.Items.LoadFromFile('c:\windows\flashamp2000.m3u');
  end
end;
procedure TPlayerForm.urlClick(Sender: TObject);
begin
  URLEntryForm.ShowModal;
end;
procedure TPlayerForm.N51Click(Sender: TObject);
begin
VolumeForm.PcmTrackBar.Position:=VolumeForm.PcmTrackBar.Position-5;
VolumeForm.MasterTrackBar.Position:=VolumeForm.MasterTrackBar.Position-5;
end;
procedure TPlayerForm.N54Click(Sender: TObject);
begin
VolumeForm.PcmTrackBar.Position:=VolumeForm.PcmTrackBar.Position+5;
VolumeForm.MasterTrackBar.Position:=VolumeForm.MasterTrackBar.Position+5;
end;
procedure TPlayerForm.XaudioPlayerNotifyPlayerState(Sender: TXaudioPlayer;
  State: Integer);
begin
  case State of
    XA_PLAYER_STATE_STOPPED:
      begin
        StatusBar.Panels[1].Text := 'STOPPED';
        XaudioPlayer.InputSeek(0, 1);
        playlist.listbox.itemindex:=playlist.listbox.itemindex +1 ;
        playerform.XaudioPlayer.inputopen(playlist.ListBox.items[playlist.listbox.itemindex]);
        xaudioplayer.play;
      end;
    XA_PLAYER_STATE_PLAYING:
      StatusBar.Panels[1].Text := 'PLAYING';
    XA_PLAYER_STATE_PAUSED:
      StatusBar.Panels[1].Text := 'PAUSED';
    XA_PLAYER_STATE_EOF:
      begin
        StatusBar.Panels[1].Text := 'EOF';
        XaudioPlayer.InputSeek(0,1);
      end;
  end;
end;
procedure TPlayerForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    playlist.ListBox.Items.SaveToFile('c:\windows\flashamp2000.m3u');
    skinbox.items.Clear;
    skinbox.Items.add(skinform.skinpath);
    skinbox.items.SaveToFile('c:\windows\flashamp2000.skin');
end;
procedure TPlayerForm.N4Click(Sender: TObject);
begin
  if sk.Execute then
  begin
    skinform.SkinPath:=sk.FileName;
    play.ApplySkin(skinform.ControlInterface);
    pause.ApplySkin(skinform.ControlInterface);
    stop.ApplySkin(skinform.ControlInterface);
    eq.ApplySkin(skinform.ControlInterface);
    pl.ApplySkin(skinform.ControlInterface);
    kj.ApplySkin(skinform.ControlInterface);
    kt.ApplySkin(skinform.ControlInterface);
    back.ApplySkin(skinform.ControlInterface);
    next.ApplySkin(skinform.ControlInterface);
    playname.ApplySkin(skinform.ControlInterface);
    DurationText1.ApplySkin(skinform.ControlInterface);
    TimecodeText.ApplySkin(skinform.ControlInterface);
    TrackBar.ApplySkin(skinform.ControlInterface);
    EqualizerForm.skinform.SkinPath:=playerform.sk.FileName;
    Equalizerform.show;
    EqualizerForm.eq1.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq2.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq3.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq4.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq5.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq6.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq7.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq8.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq9.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq10.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb1.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb2.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb3.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb4.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb5.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb6.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb7.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb8.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb9.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb10.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqa.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.equp.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqdn.ApplySkin(EqualizerForm.skinform.ControlInterface);
    end
end;
procedure TPlayerForm.exitClick(Sender: TObject);
begin
close;
end;
procedure TPlayerForm.pageClick(Sender: TObject);
begin
WinExec('Start http://www.flashamp2000.web600.com/', 0);
end;
procedure TPlayerForm.emailClick(Sender: TObject);
begin
WinExec('Start mailto:chinazh@mail.sy.ln.cn', 0);
end;
procedure TPlayerForm.N8Click(Sender: TObject);
begin
Volumeform.BalanceTrackBar.Position:=0 ;
end;
procedure TPlayerForm.N9Click(Sender: TObject);
begin
Volumeform.BalanceTrackBar.Position:=100 ;
end;
procedure TPlayerForm.N11Click(Sender: TObject);
begin
Volumeform.BalanceTrackBar.Position:=45 ;
end;
procedure TPlayerForm.N2Click(Sender: TObject);
begin
fb.show;
end;

procedure TPlayerForm.N19Click(Sender: TObject);
begin
    skinform.skinpath:='c:\windows\mfml.skn';
    play.ApplySkin(skinform.ControlInterface);
    pause.ApplySkin(skinform.ControlInterface);
    stop.ApplySkin(skinform.ControlInterface);
    eq.ApplySkin(skinform.ControlInterface);
    pl.ApplySkin(skinform.ControlInterface);
    kj.ApplySkin(skinform.ControlInterface);
    kt.ApplySkin(skinform.ControlInterface);
    back.ApplySkin(skinform.ControlInterface);
    next.ApplySkin(skinform.ControlInterface);
    playname.ApplySkin(skinform.ControlInterface);
    DurationText1.ApplySkin(skinform.ControlInterface);
    TimecodeText.ApplySkin(skinform.ControlInterface);
    TrackBar.ApplySkin(skinform.ControlInterface);
    Equalizerform.skinform.skinpath:='c:\windows\mfml.skn';
    equalizerform.Show;
    EqualizerForm.eq1.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq2.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq3.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq4.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq5.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq6.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq7.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq8.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq9.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq10.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb1.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb2.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb3.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb4.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb5.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb6.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb7.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb8.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb9.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqb10.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqa.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.equp.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eq.ApplySkin(EqualizerForm.skinform.ControlInterface);
    EqualizerForm.eqdn.ApplySkin(EqualizerForm.skinform.ControlInterface);
end;
procedure TPlayerForm.FormCreate(Sender: TObject);
begin
skinbox.Items.LoadFromFile('c:\windows\flashamp2000.skin');
skinbox.ItemIndex:=0;
skinform.SkinPath:=skinbox.Items[skinbox.itemindex];
end;
end.
